<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>

<HEAD>

<TITLE>CGIservlet manual</TITLE>


</HEAD>

<BODY>

<H1 ALIGN="CENTER">CGIservlet</H1>

<P>
A HTTPd "connector" for running CGI scripts on unix systems as WWW
accessible Web sites. The servlet starts a true HTTP daemon that channels 
HTTP requests to forked daughter processes. CGIservlet.pl is NOT a
full fledged server. Moreover, this servlet is definitely NOT intended 
as a replacement for a real server (e.g., Apache). It's design goal was
SIMPLICITY, and not mileage.
</P>

<P>
Note that a HTTP server can be accessed on your local machine WITHOUT 
internet access: 
use "http://localhost[:port]/[path]" or "http://127.0.0.1[:port]/[path]" 
as the URL. It is also easy to restrict access to the servlet to localhost
users (i.e., the computer running the servlet).
</P>

<P>
Suggested uses:
</P>

<ul>
    <li> 
    
    <P>
    A testbed for CGI-scripts and document-trees outside the primary server.
    When developing new scripts and services, you don't want to mess up your
    current Web-site. CGIservlet is an easy way to start a temporary (private) 
    server. CGIservlet allows to test separate HTTP server components, e.g., 
    user authentication, in isolation.
    </P>
    
    <li> 
    
    <P>
    A special purpose temporary server (WWW everywhere/anytime). 
    We run identification and other experiments over the inter-/intra-net using 
    CGI-scripts. This means a lot of development and changes and only little
    actual run-time. The people doing this do not want "scripting" access to our 
    departmental server with all its restrictions and security. So we need a 
    small, lightweigth, easy-to-configure server that can be run by each
    investigator on her own account (and risk).
    </P> 
    
    <li> 
    
    <P>
    Interactive WWW presentations.
    Not everyone is content with the features of "standard" office presentation 
    software. HTML and its associated browsers are an alternative (especially 
    under Linux). However, you need a server to realize the full interactive 
    nature of the WWW. CGIservlet with the necessary scripts can be run from 
    a floppie (a Web server in 100 kB). The CGIservlet can actually run a 
    (small) web site from RAM, without disk access (if you DONOT use the 
    2>pid.log redirection on startup). 
    With the "localhost" or "127.0.0.1" id in your browser you can use it 
    standalone.
    </P>
    
</ul>          

<P>
When the servlet is started with the -r option, only requests from "localhost" 
or "127.0.0.1" are accepted (default) or from addresses indicated after the
-r switch.
</P>         

<P>
Running demo's and more information can be found at 
<A HREF="http://www.fon.hum.uva.nl/rob/OSS/OSS.html">
http://www.fon.hum.uva.nl/rob/OSS/OSS.html</A>
</P>

<H2 ALIGN="CENTER">Inner workings</H2>

<P>
Whenever an HTTP request is received, the specified CGI script is 
started inside a child process as if it was inside a real server (e.g., 
Apache). The evironment variables are set more or less as in Apache. 
Note that CGIservlet only uses a SINGLE script for ALL requests.
No attemps for security are made, it is the script's responsibility to 
check access rights and the validity of the request.<br>
When no scripts are given, CGIservlet runs as a bare bone WWW server
configurable to execute scripts (the default setting is as a STATIC server).
</P>

<PRE>
Use:    CGIservlet.pl -&lt;switch&gt; &lt;argument&gt; 2&gt;pid.log &     (sh)
        CGIservlet.pl -&lt;switch&gt; &lt;argument&gt; &gt;&pid.log &     (csh)
        </PRE>
        
        <P>
        The servlet prints out pid and port number on STDERR. It is
        adviced to store these in a separate file (this will become the
        error log). <BR>
        NOTE: When running CGIservlet from a Memmory Image (i.e. RAM),
        do NOT redirect the error output to a file, but use something
        like MAILTO!
        </P>
        
        <PRE>
Stop:   sh pid.log                      (kills the server process)
</PRE>

<P>
The first line in the file that receives STDERR output is a command
to stop CGIservlet.
</P>

<P>
examples:
</P>

<PRE>
CGIservlet.pl -p 2345 -d /cgi-bin/CGIscriptor.pl -t /WWW 2>pid.log &
CGIservlet.pl -p 8080 -b 'require "CGIscriptor.pl";' -t $PWD -e 'Handle_Request();' 2>pid.log &
</PRE>

<P>
The following example settings implement a static WWW server using 'cat'
(and prohibiting Queries):
<dl>
<dt>-p 8080 
<dt>-t `pwd`
<dt>-b ''
<dt>-e 
'exit if $ENV{QUERY_STRING};$ENV{PATH_INFO}=~/\.([\w]+)$/; "Content-type: ".$mimeType{uc($1)}."\n\n";'
<dt>-d 'cat -u -s'
<dt>-w '/index.html'
<dt>-c 32
<dt>-l 512
</dl>

This is identical to the (static) behaviour of CGIservlet when 
-e '' -d '' -x '' is used.
<br>
The CGIservlet command should be run from the intended server-root directory.
</P>

<P>
Another setting will use a package 'CGIscriptor.pl' with a function
'HandleRequest()' to implement an interactive WWW server with inline Perl 
scripting:
<dl>
<dt>-p 8080 
<dt>-t `pwd` 
<dt>-b 'require "CGIscriptor.pl";' 
<dt>-e 'HandleRequest();'
<dt>-d ''
<dt>-w '/index.html'
<dt>-c 32
<dt>-l 32767
</dl>
</P>

<P>
Look in the source code or in the CGIservletSETUP.pl file for the current 
default settings.
</P>

<H2 ALIGN="CENTER">Command-line switches</H2>

<P>
There are many switches to tailor the workings of CGIservlet.pl.
Some are fairly esoteric and you should only look for them if you
need something special urgently. When building a Web site, 
the specific options you need will "suggest" themselves (e.g., port
number, script, or server-root directory). Most default settings 
should work fine. 
</P>

<P>
You can add your own configuration in a file
called 'CGIservletSETUP.pl'. This file will be executed ("eval"-ed) 
after the default setup, but before the command line options take 
effect. CGIservlet looks for the SETUP file in the startup directory
and in the CGIscriptor subdirectory.<br>
(Note that the $beginarg variable is evaluated AFTER the setup file).
</P>

<P>
In any case, it is best to change the default settings instead of
using the option switches. All defaults are put in a single block.
</P>

<P>
<H3>switches and arguments</H3>
</P>

<dl>
    <dt>Realy important
    <ul>
        <li>-p[ort] port number<br>
        For example -p 2345<br>
        Obviously the port CGIservlet listenes to. Default: -p 8080
          
        <li>-a[lias] Alias1 RealURL1 ...<br>
        For example -a '/Stimulus.aifc' '/catAIFC.xmr'<br>
        Replaces the given Alias URL path by its real URL path. Accepts full 
        regular expressions too (identified by NON-URL characters).<br>
        That is, on each request it performs (in order):<br>
        <pre>
if($AliasTranslation{$Path})
{ 
    $Path = $AliasTranslation{$Path};
}
elsif(@RegAliasTranslation)
{  
    my $i;
    for($i=0; $i&lt;scalar(@RegAliasTranslation); ++$i)
    { 
        my $Alias   = $RegAliasTranslation[$i];
        my $RealURL = $RegURLTranslation[$i];
        last if ($Path =~ s#$Alias#$RealURL#g);
    };
};
         </pre>
         <p>
         The effects can be quite drastic, so be 
         carefull. Note also, that entering many Regular Expression
         aliases could slow down your servlet. Checking stops after 
         the first match.<br>
         Full regular expression alias translations are done in the
         order given! They are recognized as Aliases containing 
         regexp's (i.e., non-URL) operator characters like '^' and
         '$'.<br>
         Note: The command line is NOT a good place for entering
         Aliases, change the code below or add aliases to 
         CGIservletSETUP.pl.
        </p>
        
        <li>--help<br>
        Prints the manual
        
    </ul>
    
    <dt>Script related
    <ul>
        <li>-b[egin] perl commands<br>
        For example -b 'require "CGIscriptor.pl";' or
        'require "/WWW/cgi-bin/XMLelement.pl";'<br>
        Perl commands evaluated at startup
        
        <li>-d[o] perl script file<BR>
        For example -d '/WWW/cgi-bin/CGIscriptor.pl'<br>
        The actual CGI-script started as a perl {do "scriptfile"} command.
        The PATH_INFO and the QUERY are pushed on @ARGV.
        
        <li>-x shell command
        <li>-qx shell command
        <li>-exec shell command<br>
        OS shell script or command, e.g., -x 'CGIscriptor.pl' or
        -x '/WWW/cgi-bin/my-script' <br>
        The actual CGI-script started as `my-script \'$Path\' \'$QueryString\'`. 
        -qx and -exec[ute] are aliases of -x. For secutiry reasons, Paths or
        queries containing '-quotes are rejected.
        
        <li>-e[val] perl commands<br>
        For example -e 'Handle_Request();'   <br>
        The argument is evaluated as perl code. The actual CGI-script 
        can be loaded once with -b 'require module.pm' and you only have to 
        call the central function(s).
    </ul>
    
    <dt>WWW-tree related
    <ul>
        <li>-t[extroot] path
        For example -t "$PWD" or -t "/WWW/documents"<br>
        The root of the server hierachy. Defaults to the working directory
        at startup time (`pwd`)  
        
        <li>-w[elcome] filepath
        For example -w "/index.html"   (default)<br>
        The default welcome page used when no path is entered. Note that
        this path can point to anything (or nothing real at all).
    </ul>
    <dt>Security related<br>
    The following arguments supply some rudimentary security. It is the
    responsibility of the script to ensure that the requests are indeed
    "legal".
    <ul>
        <li>-c[hildren] maximum child processes<br>
        For example -c 32<br>
        The maximum number of subprocesses started. If there are more requests,
        the oldest requests are "killed". This should take care of "zombie"
        processes and server overloading. Note that new requests will be 
        serviced irrespective of the success of killing it's older siblings.
        
        <li>-xtime maximum running time of a child<br>
        For example -xtime 36000<br>
        The maximum time a child may run in seconds. After a new request has 
        been servised, all children that have run for longer than this time 
        will be killed. This stops runaway processes, often connected to
        web-crawlers. 

        <li>-l[ength] maximum length of request in bytes<br>
        For example -l 32768 <br>
        This prevents overloading the server with enormous queries. Reading of
        requests simply stops when this limit is reached. This DOES affect 
        POST requests.  If the combined length of the COMPLETE HTTP request,
        including headers, exceeds this limit, the whole request is dropped.
        
        <li>-r[estrict] [Remote-address [Remote-host]]<br>
        For example -r 127.0.0.1          (default of -r)<br>
        A space separated list of client IP addresses and/or domain names that
        should be serviced. Default, i.e., '-r' without any addresses or domain
        names, is the localhost IP address '127.0.0.1'.<br>
        When using CGIservlet for local purposes only (e.g., development or a 
        presentation), it would be unsafe to allow others to access the servlet.
        If -r is used (or the corresponding @RemoteAddr or @RemoteHost lists are
        filled in the code below), all requests from clients whose Remote-address
        or Remote-host do not match the indicated addresses will be rejected.
        Partial addresses and domain names are allowed. Matching is done according 
        to Remote-addr =~ /^\Q$pattern\E/ (front to back) and 
        Remote-host =~ /\Q$pattern\E$/ (back to front)

		<li>--env name=value,name=value<br>
		Watch double dash. Define $ENV{name}=value for every pair. These are 
		internally stored in %UserEnv, eg, $UserEnv{name}=value; This is set anew 
		in the Child with every request. That is, Changes in %ENV are not stored.
		
		<li>--USEFAT<br>
		Watch double dash. Define $ENV{USEFAT}=1. This is used to signal that 
		runs from an MS FAT file system without file permissions.
		
        <li>-m[emory]<br>
        No arguments.<br>
        Reads complete Web site into memory and runs from this image.
        Set $UseRAMimage = 1; to activate memory-only running.<br>
        Note that running osshellscripts from this
        image makes any "security" related claims very shaky.<br>
    </ul>   
    <dt>Speedup
    <ul>
        <li>-n[oname]<br>
        No arguments. <br>
        Retrieving the domain name of the Client (i.e., Remote-host) is a
        very slow process and normally useless. To skip it, enter this 
        option. Note that you cannot use '-r Remote-host' anymore after 
        you enter -n, only IP addresses will work.
    </ul>
</dl>

<H3 ALIGN="CENTER">Configuration with the <a href="/CGIservletSETUP.pl">CGIservletSETUP.pl</a> file</H3>

<P>
You can add your own configuration in a file
called '<a href="/CGIservletSETUP.pl">CGIservletSETUP.pl</a>'. 
This file will be executed ("eval"-ed) 
after the default setup, but before the command line options take 
effect. CGIservlet looks for the SETUP file in the startup directory
and in the CGIservlet and CGIscriptor subdirectories.
(Note that the $beginarg variable is evaluated even later).
</P>


<H3 ALIGN="CENTER">Changing POST to GET requests</H3>

<P>
CGIservlet normally only handles requests with the GET method. Processing
the input from POST requests is left to the reading application. POST 
requests add some extra complexity to processing requests. Sometimes,
the reading application doesn't handle POST requests. CGIservlet
already has to manage the HTTP request. Therefore, it can easily
handle the POST request. If the variable $POSTtoGET is set to any
non-false value, the content of whole POST request is added to the
QUERY_STRING environment variable (preceeded by a '&' if necessary).
The content-length is set to 0. If $POSTtoGET equals 'GET', the method 
will also be changed to 'GET'.
</P>

<H3>remarks:</H3>

<P>
All of the arguments of -d, -x, and -e are processed sequentially
in this order. This might not be what you want so you should be 
carefull when using multiple executable arguments.
If none of the executable arguments is DEFINED (i.e., they are entered
as -d '' -e '' -x ''), each request is treated as a simple 
text-retrieval. THIS CAN BE A SECURITY RISK!
</P>

<P>
The wiring of an interactive web-server, which also calls shell 
scripts with the extension '.cgi', is in place. You can 
"activate" it by changing the "$ExecuteOSshell = 0;" line to 
"$ExecuteOSshell = 1;".<br>
If you have trouble doing this, it might be a good idea
to reconsider using a dynamic web server. Executing shell
scripts inside a web server is a rather dangerous practise.
</P>

<P>
CGIservlet can run its "standard" web server from memory. 
At startup, all files are read into a hash table.  Upon
request, the contents of the file are placed in the
environment variable: CGI_FILE_CONTENTS.<br>
No further disk access is necessary. This means that:
<ol>
    <li> CGIservlet can run a WWW site from a removable disk, 
    e.g., a floppy
    <li> The web servlet can run without any read or write privilege.
    <li> The integrity of the Web-site contents can be secured at the
    level you want
</ol>
To compres the memory (RAM) immage, you should hook the 
compression function to <br>
$CompressRAMimage = sub { return shift;}; <br>
and the decompression function to <br>
$DecompressRAMimage = sub { return shift;}; <br>
</P>

<H2 ALIGN="CENTER">license</H2>                                                            

<P>
This program is free software; you can redistribute it and/or       
modify it under the terms of the GNU General Public License         
as published by the Free Software Foundation; either version 2      
of the License, or (at your option) any later version.
</P>

<P>
This program is distributed in the hope that it will be useful,     
but WITHOUT ANY WARRANTY; without even the implied warranty of      
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
GNU General Public License for more details.
</P>

<P>
You should have received a copy of the GNU General Public License   
along with this program; if not, write to the Free Software         
Foundation, Inc., 59 Temple Place - Suite 330,                      
Boston, MA  02111-1307, USA.
</P>

<PRE>
Author: Rob van Son 
        email:
        R.J.J.H.vanSon@gmail.com 
        Institute of Phonetic Sciences/ACLC
        University of Amsterdam

        copying freely from the mhttpd server by Jerry LeVan (levan@eagle.eku.edu)
Date:   15 Jan 2002
Ver:    1.3
Env:    Perl 5.002 and later

Note:   CGIservlet.pl was directly inspired by Jerry LeVan's 
        (levan@eagle.eku.edu) simple mhttpd server which again was 
        inspired by work of others. CGIservlet is used as a bare bones 
        socket server for a single CGI script at a time.
</PRE>

</BODY>

</HTML>
